<?php
/*
Plugin Name: Clock in Portal 
Plugin URI:  http://weblizar.com
Description: Track the attendance of all registered employees with clock in or out system , Easy salary management , Shift management for employees (users).
Version:     1.4
Author:      Weblizar
Author URI:  http://weblizar.com
Domain Path: /languages
Text Domain: clock-in-portal
*/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

define("CIP_TXTDM","clock-in-portal" );
define( 'CIP_PLUGIN_NAME', __('Clock In Portal', CIP_TXTDM ) );
define("CIP_PLG_URL", plugin_dir_url(__FILE__));

//Include files 
include( plugin_dir_path( __FILE__ ) . 'inc/custom_function.php');

add_action('plugins_loaded', 'CIP_Language_Translater');
function CIP_Language_Translater() {
	load_plugin_textdomain( CIP_TXTDM , FALSE, dirname( plugin_basename(__FILE__)).'/languages' );
}

// on activation
register_activation_hook( __FILE__, 'cip_run_install' );
function cip_run_install(){
	require("install-script.php");
}

register_activation_hook( __FILE__, 'cip_intsert_data' );
function cip_intsert_data() {
	global $wpdb;	
	$id = "1";
	$name  = "default";
	$color  = "#fff";
	$status  = "1";
	$staff_category_table = $wpdb->prefix . "sm_staff_category";
	// first check if data exists with select query
	//$result = $wpdb->get_results("SELECT * FROM $staff_category_table WHERE id= '".$id."'");
	$result = $wpdb->get_results("SELECT * FROM $staff_category_table");
	if($wpdb->num_rows > 0) {
	}
	// if not exist in the database then insert it
	else{
		$rows_affected = $wpdb->insert( $staff_category_table, array( 'id' => 1, 'name' => $name, 'color' => $color, 'status' => $status ));	
	}
}

// on deactivation
register_deactivation_hook( __FILE__, 'cip_run_uninstall' );
function cip_run_uninstall(){
	// do nothing
}
add_action( 'admin_menu', 'cip_plugin_menu' );
function cip_plugin_menu() {

	if($staff_request = get_option("cip_staff_event_request")) {	
		$i=0;
		foreach($staff_request as $key => $staff_request) {			
			$status = $staff_request['status'];			
			if($status == 1) {							
				$i = $i+1;					
			}
			if($i > 0){
			$LeaveRequest = 'Leave Request <span class="update-plugins count-1"><span class="plugin-count">'.$i.'</span></span>';
			}else{
				$LeaveRequest = 'Leave Request';
			}
		}	
	}else{
		$LeaveRequest = 'Leave Request';	
	}
		
	$cip_menu1 = add_menu_page( CIP_PLUGIN_NAME, __(CIP_PLUGIN_NAME, CIP_TXTDM), 'administrator', 'clock-in-portal', 'cip_dashboard', 'dashicons-clock', 65 );
	$cip_menu2 = add_submenu_page( 'clock-in-portal', 'Reports', __('Reports', CIP_TXTDM), 'administrator', 'cip-reports', 'cip_reports');
	$cip_menu3 = add_submenu_page( 'clock-in-portal', 'Staffs', __('Staff', CIP_TXTDM), 'administrator', 'cip-staffs', 'cip_staffs');
	$cip_menu4 = add_submenu_page( 'clock-in-portal', 'Designations',__('Designations', CIP_TXTDM), 'administrator', 'cip-designations', 'cip_designations');
	$cip_menu5 = add_submenu_page( 'clock-in-portal', 'Holidays',__('Holidays', CIP_TXTDM), 'administrator', 'cip-holidays', 'cip_holidays');
	$cip_menu6 = add_submenu_page( 'clock-in-portal', $LeaveRequest, __($LeaveRequest, CIP_TXTDM), 'administrator', 'cip-staff-request', 'cip_staff_request');
	$cip_menu7 = add_submenu_page( 'clock-in-portal', 'Settings',__('Settings', CIP_TXTDM), 'administrator', 'cip-settings', 'cip_settings');
	$cip_menu8 = add_submenu_page( 'clock-in-portal', 'How to Work',__('How to Work', CIP_TXTDM), 'administrator', 'cip-help', 'cip_help');
	$cip_menu8 = add_submenu_page( 'clock-in-portal', 'Our Products',__('Our Products', CIP_TXTDM), 'administrator', 'cip-our-products', 'cip_our_products');
	
	add_action( 'admin_print_styles-' . $cip_menu1, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu2, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu2, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu3, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu4, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu5, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu6, 'cip_css_js' );
	add_action( 'admin_print_styles-' . $cip_menu7, 'cip_css_js' );	
	add_action( 'admin_print_styles-' . $cip_menu8, 'cip_css_js' );
	
  	global $wpdb;
	$staff_table = $wpdb->prefix . "sm_staffs";
	// get user details & id
	$current_user = wp_get_current_user();
	$userid = $current_user->ID;
	
  if($userdata = $wpdb->get_row($wpdb->prepare("SELECT * FROM `$staff_table` WHERE status = 1 AND `staff_id` = %d", $userid))) {
		$allowed_roles = array('editor', 'subscriber', 'author', 'contributor', 'shop_manager');
		foreach($allowed_roles as $userroles ) {			
			if($userroles == $current_user->roles[0]){				
				$cip_menu10 = add_submenu_page( 'clock-in-portal', 'Dashboard', __('Dashboard', CIP_TXTDM), $userroles, 'subscribers-staff-attendance', 'cip_subscribers_staff_attendance');
				$cip_menu11 = add_submenu_page( 'clock-in-portal', 'Reports', __('Reports', CIP_TXTDM), $userroles, 'subscribers-staff-reports', 'cip_subscribers_staff_reports');
				$cip_menu12 = add_submenu_page( 'clock-in-portal', 'Holidays', __('Holidays', CIP_TXTDM), $userroles, 'subscribers-staff-holidays', 'cip_subscribers_staff_holiodays');
				$cip_menu13 = add_submenu_page( 'clock-in-portal', 'Leave Request', __('Leave Request', CIP_TXTDM), $userroles, 'subscribers-staff-request', 'cip_subscribers_staff_request');
				add_action( 'admin_print_styles-' . $cip_menu10, 'cip_css_js' );
				add_action( 'admin_print_styles-' . $cip_menu11, 'cip_css_js' );
				add_action( 'admin_print_styles-' . $cip_menu12, 'cip_css_js' );
				add_action( 'admin_print_styles-' . $cip_menu13, 'cip_css_js' );
			}
		}
	}
}

// load js css in admin dashboard
function cip_css_js(){
	//js
	wp_enqueue_script( 'jquery');
	wp_enqueue_script( 'cip-bootstrap-js', CIP_PLG_URL.'/js/bootstrap.js', array('jquery'), '', true);
	wp_enqueue_script( 'cip-flipclock-js', CIP_PLG_URL.'/js/flipclock.js', array('jquery'), '', false);
	wp_enqueue_script( 'cip-jquery-date-format-js', CIP_PLG_URL.'/js/jquery-date-format.js', array('jquery'), '', true);
	wp_enqueue_script( 'cip-moment-js', CIP_PLG_URL.'/js/moment.js', array('jquery'), '', true);
	wp_enqueue_script( 'cip-bootstrap-datetimepicker-js', CIP_PLG_URL.'/js/bootstrap-datetimepicker.min.js', array('jquery'), '', true);
	
	//css
	wp_enqueue_style( 'wp-color-picker' );
	wp_enqueue_style( 'cip-flip-clock-css', CIP_PLG_URL.'/css/flipclock.css');
	wp_enqueue_style( 'cip-dashboard-css', CIP_PLG_URL.'/css/cip-dashboard.css');
	wp_enqueue_style( 'cip-bootstrap-css', CIP_PLG_URL.'/css/bootstrap.css');	
	wp_enqueue_style( 'cip-font-awesome-css', CIP_PLG_URL.'/css/font-awesome.css');
	wp_enqueue_style( 'cip-style-css', CIP_PLG_URL.'/css/style.css');
	wp_enqueue_style( 'cip-bootstrap-date-time-picker-css', CIP_PLG_URL.'/css/bootstrap-datetimepicker.min.css');
}

function my_login_redirect( $url, $request, $user ){
if( $user && is_object( $user ) && is_a( $user, 'WP_User' ) ) {
if( $user->has_cap( 'administrator') ) {
$url = admin_url();
} else {
$url = admin_url('/admin.php?page=subscribers-staff-attendance/');
}
}
return $url;
}
add_filter('login_redirect', 'my_login_redirect', 10, 3 );



//*** ADMIN PAGES ***//

//dashboard
function cip_dashboard() {
	require('dashboard.php');
}
//report
function cip_help() {
	require('help.php');
}

//report
function cip_reports() {
	require('reports.php');
}

//staffs
function cip_staffs() {
	require('staffs.php');
}

//designations
function cip_designations() {
	require('designations.php');
}


//holidays
function cip_holidays() {
	require('holidays.php');
}

//features
function cip_features() {
	require('pro_features.php');
}

//Staff Request
function cip_staff_request() {
	require('staff-request.php');
}

//settings
function cip_settings() {
	require('settings/settings.php');
}

//*** Subscriber Pages ***//

//subscribers-staff-attendance
function cip_subscribers_staff_attendance() {
	require('subscribers/staff-attendance.php');
}

//subscribers-staff-reports
function cip_subscribers_staff_reports() {
	require('subscribers/staff-reports.php');
}
//subscribers-staff-holidays
function cip_subscribers_staff_request() {
	require('subscribers/staff-request.php');
}

//subscribers-staff-holidays
function cip_subscribers_staff_holiodays() {
	require('subscribers/staff-holidays.php');
}

// our products
function cip_our_products() {
	require('our-products.php');
}
?>