<?php 
// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

// get all records
global $wpdb;
$staff_category_table = $wpdb->prefix . "sm_staff_category";
?>
<h1><?php _e('Designation Management', CIP_TXTDM );?></h1>
<h1>
	<button type="button" class="btn btn-success" data-toggle="modal" data-target="#add-designation-modal"><i class="fa fa-thumb-tack" aria-hidden="true"></i><?php _e(' Add Staff Designation', CIP_TXTDM );?></button>
</h1>
<div>
	<table class="table table-hover">
		<thead>
			<tr class="info">
				<th>#</th>
				<th><?php _e('Designation', CIP_TXTDM );?></th>
				<th><?php _e('Color', CIP_TXTDM );?></th>
				<th><?php _e('Status', CIP_TXTDM );?></th>
				<th><?php _e('Action', CIP_TXTDM );?></th>
			<tr>
		<thead>
		<tbody>
			<?php
				//get all staffs designation
				if(count($all_staff_categories = $wpdb->get_results("SELECT * FROM `$staff_category_table`"))){
					$no = 1;
					foreach($all_staff_categories as $staff_category) {
						$id = ucwords($staff_category->id);
						$name = ucwords($staff_category->name);
						$color = strtoupper($staff_category->color);
						if($staff_category->status) $status = "Available"; else $status = "Unavailable";
			?>
			<tr>
				<td><?php echo $no; ?>.</td>
				<td><?php echo $name; ?></td>
				<td><span style="background-color: <?php echo $color; ?>; opacity: 0.7; padding: 4px;"><?php echo $color; ?></span></td>
				<td><?php echo $status; ?></td>
				<td>
					<a href="#" class="btn btn-info" title="View" data-toggle="modal" data-target="#view-designation-modal" onclick="return DoAction('view', '<?php echo $id; ?>');"><i class="fa fa-eye" aria-hidden="true"></i></a>
					<a href="#" class="btn btn-info" title="Update" data-toggle="modal" data-target="#update-designation-modal" onclick="return DoAction('update', '<?php echo $id; ?>');"><i class="fa fa-pencil" aria-hidden="true"></i></a>
					<?php if($no > 1) { ?>
					<a href="#" class="btn btn-info" title="Delete" onclick="return DoAction('delete', '<?php echo $id; ?>');"><i class="fa fa-times" aria-hidden="true"></i></a>
					<?php } ?>
				</td>
			</tr>
			<?php
					$no++;
					}// end foreach
				} else {
					echo "<tr><td colspan=5 class='text-center'>No Record Found.</td></tr>";
				}
			?>
		</tbody>
		<thead>
			<tr class="info">
				<th>#</th>
				<th><?php _e('Designation', CIP_TXTDM );?></th>
				<th><?php _e('Color', CIP_TXTDM );?></th>
				<th><?php _e('Status', CIP_TXTDM );?></th>
				<th><?php _e('Action', CIP_TXTDM );?></th>
			<tr>
		<thead>
	</table>	
</div>


<!-- Add Staff Designation Modal-->
<div class="modal fade" id="add-designation-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<form id="add-designation-form" name="add-designation-form">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					<h4 class="modal-title" id="myModalLabel"><?php _e('Add New Staff Designation', CIP_TXTDM );?></h4>
				</div>
				<div class="modal-body">
					<div class="form-group">
						<label for="Password"><?php _e('Designation Name', CIP_TXTDM );?></label>
						<input type="input" class="form-control" id="name" name="name" placeholder="Type Designation">
						<?php wp_nonce_field( 'add_designation_nonce_action', 'add_designation_nonce_name' ); ?>
					</div>
					<div class="form-group">
						<label for="Color"><?php _e('Designation Color', CIP_TXTDM );?></label>
						<input type="color" class="form-control" id="color" name="color" value="#EE2724">
					</div>
					<div class="form-group">
						<label for="Status"><?php _e('Designation Status', CIP_TXTDM );?></label>
						<select id="status" name="status" class="form-control">
							<optgroup label="Select Any Status">
								<option value="1"><?php _e('Available', CIP_TXTDM );?></option>
								<option value="0"><?php _e('Unavailable', CIP_TXTDM );?></option>
							</optgroup>
						</select>
					</div>					
				</div>
				<div class="modal-footer">
					<div id="add-loading-icon" style="display:none;">
						<?php _e('Processing...', CIP_TXTDM );?><i class="fa fa-spinner fa-3x" aria-hidden="true"></i>
					</div>
					<button id="add-designation" name="add-designation" type="button" class="btn btn-primary" onclick="return DoAction('add', '');"><?php _e('Add Designation', CIP_TXTDM );?></button>
					<button id="add-close" name="add-close" type="button" class="btn btn-default" data-dismiss="modal"><?php _e('Close', CIP_TXTDM );?></button>
				</div>
			</form>
		</div>
	</div>
</div>

<!-- View Staff Designation Modal -->
<div class="modal fade" id="view-designation-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
				<h4 class="modal-title" id="myModalLabel"><?php _e('View Staff Designation', CIP_TXTDM );?></h4>
			</div>
			<div class="modal-body" id="view-modal-body">
				<div id="view-loading-icon" style="display:none;">
					<?php _e('Processing...', CIP_TXTDM );?><i class="fa fa-spinner fa-3x" aria-hidden="true"></i>
				</div>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal"><?php _e('Close', CIP_TXTDM );?></button>
			</div>
		</div>
	</div>
</div>

<!-- Update Staff Designation Modal -->
<div class="modal fade" id="update-designation-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<form id="update-designation-form" name="update-designation-form">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					<h4 class="modal-title" id="myModalLabel"><?php _e('Update Staff Designation', CIP_TXTDM );?></h4>
				</div>
				<div class="modal-body" id="update-modal-body">
				</div>
				<div class="modal-footer">
					<div id="update-loading-icon" style="display:none;">
						<?php _e('Processing...', CIP_TXTDM );?><i class="fa fa-spinner fa-3x" aria-hidden="true"></i>
					</div>
					<button id="update-designation" name="update-designation" type="button" class="btn btn-primary" onclick="return DoAction('update-now', '');"><?php _e('Update Designation', CIP_TXTDM );?></button>
					<button id="update-close" name="update-close" type="button" class="btn btn-default" data-dismiss="modal"><?php _e('Close', CIP_TXTDM );?></button>
				</div>
			</form>
		</div>
	</div>
</div>

<script>
//tabs
jQuery('#myTabs a').click(function (e) {
  e.preventDefault()
  jQuery(this).tab('show');
});

// add staff modal call
jQuery('#staff-modal').on('shown.bs.modal', function (){ });

// add designation modal call
jQuery('#add-designation-modal').on('shown.bs.modal', function (){
	jQuery("#add-loading-icon").hide();
});

// action handler for: designation, action: view/add/update/delete
function DoAction(action, id){
	console.log(action);
	var data_values = "";	
	
	//add
	if(action == "add") {
		var name = jQuery("#name").val();
		if(name == "") {
			jQuery("#name").after("Required field.");
			return false;
		}
	
		jQuery("#add-designation").hide();
		jQuery("#add-close").hide();
		jQuery("#add-loading-icon").show();
		var data_values = jQuery("#add-designation-form").serialize() + "&action=" + action + "&id=" + id;
		//post data
		jQuery.ajax({
			type: "post",
			url: location.href,
			data: data_values,
			contentType: "application/x-www-form-urlencoded",
			success: function(responseData, textStatus, jqXHR) {
				var result = jQuery(responseData).find('div#action-result');
				jQuery("#add-loading-icon").hide();
				//jQuery(".modal-body").html(result);
				location.reload();
			},
			error: function(jqXHR, textStatus, errorThrown) {
				//console.log(errorThrown);
			}
		});
	}
	
	//view
	if(action == "view") {
		jQuery("div#view-action-result").remove();
		jQuery("#view-loading-icon").show();
		var data_values = "action=" + action + "&id=" + id;
		//post data
		jQuery.ajax({
			type: "post",
			url: location.href,
			data: data_values,
			contentType: "application/x-www-form-urlencoded",
			success: function(responseData, textStatus, jqXHR) {
				var result = jQuery(responseData).find('div#view-action-result');
				jQuery("#view-loading-icon").hide();
				jQuery("#view-modal-body").after(result);
			},
			error: function(jqXHR, textStatus, errorThrown) {
				//console.log(errorThrown);
			}
		});
	}
	
	//update - fetch data
	if(action == "update") {
		jQuery("div#update-action-result").remove();
		jQuery("#update-loading-icon").show();
		var data_values = "action=" + action + "&id=" + id;
		//post data
		jQuery.ajax({
			type: "post",
			url: location.href,
			data: data_values,
			contentType: "application/x-www-form-urlencoded",
			success: function(responseData, textStatus, jqXHR) {
				var result = jQuery(responseData).find('div#update-action-result');
				jQuery("#update-loading-icon").hide();
				jQuery("#update-modal-body").after(result);
			},
			error: function(jqXHR, textStatus, errorThrown) {
				//console.log(errorThrown);
			}
		});
	}
	
	//update now
	if(action == "update-now") {
		var name = jQuery("#update-designation-form #name").val();
		if(name == "") {
			jQuery("#update-designation-form #name").after("Required field.");
			return false;
		}
		jQuery("#update-designation").hide();
		jQuery("#update-close").hide();
		jQuery("#update-loading-icon").show();
		var data_values = jQuery("#update-designation-form").serialize() + "&action=" + action;
		//post data
		jQuery.ajax({
			type: "post",
			url: location.href,
			data: data_values,
			contentType: "application/x-www-form-urlencoded",
			success: function(responseData, textStatus, jqXHR) {
				var result = jQuery(responseData).find('div#upate-now-action-result');
				jQuery("#update-loading-icon").hide();
				location.reload();
			},
			error: function(jqXHR, textStatus, errorThrown) {
				//console.log(errorThrown);
			}
		});
	}
	
	if(action == "delete") {
		var data_values = "action=" + action + "&id=" + id;
		if (confirm("Are you sure and want to delete this designation now?") == true) {
			//post data
			jQuery.ajax({
				type: "post",
				url: location.href,
				data: data_values,
				contentType: "application/x-www-form-urlencoded",
				success: function(responseData, textStatus, jqXHR) {
					var result = jQuery(responseData).find('div#delete-action-result');
					location.reload();
				},
				error: function(jqXHR, textStatus, errorThrown) {
					//console.log(errorThrown);
				}
			});
		}
	}
}
</script>

<?php
//Action Executor
if((isset($_POST['action']))) {
	global $wpdb;
	$action = sanitize_text_field($_POST['action']);

	//add
	if($action == "add") {
		if ( ! wp_verify_nonce( $_POST['add_designation_nonce_name'], 'add_designation_nonce_action' ) ) {
			print 'Sorry, your add designation nonce did not verify.';
			exit;
		} else {
			// nonce verified - process form data	
			$name = sanitize_text_field($_POST['name']);
			$color = sanitize_text_field($_POST['color']);
			$status = sanitize_text_field($_POST['status']);
			if($wpdb->query($wpdb->prepare("INSERT INTO `$staff_category_table` (`id`, `name`, `color`, `status`) VALUES (NULL, %s, %s, %d)", $name, $color, $status))){
				echo "<div id='action-result'>Success: Designation added.</div>";
			} else {
				echo "<div id='action-result'>Error: Unable to add designation.</div>";
			}
		}
	}

	//view
	if($action == "view") {
		$id = sanitize_text_field($_POST['id']);
		if($designation = $wpdb->get_row($wpdb->prepare("SELECT * FROM `$staff_category_table` WHERE `id` = %d", $id))){
			$name = $designation->name;
			$color = $designation->color;
			$status = $designation->status;
			if($status) $status = "Available"; else $status = "Unavailable";
			echo "<div id='view-action-result'>
			<table class='table'>
				<tr>
					<td><label>Designation</label></td>
					<td>$name</td>
				</tr>
				<tr>
					<td><label>Color</label></td>
					<td><span style='background-color: $color; opacity: 0.7; padding: 4px;'>$color</span></td>
				</tr>
				<tr>
					<td><label>Staus</label></td>
					<td>$status</td>
				</tr>
			</table>
			</div>";
		} else {
			echo "<div id='action-result'>Error: Unable to fetch data.</div>";
		}
	}
	
	//update
	if($action == "update") {
		$id = sanitize_text_field($_POST['id']);
		if($designation = $wpdb->get_row($wpdb->prepare("SELECT * FROM `$staff_category_table` WHERE `id` = %d", $id))){
			$name = $designation->name;
			$color = $designation->color;
			$status = $designation->status;
			if($status) $status = "Available"; else $status = "Unavailable";
			echo "<div id='update-action-result'>
			<table class='table'>
				<tr>
					<td><label>Designation</label></td>
					<td>
						<input type='hidden' class='form-control' id='id' name='id' value='$id'>
						<input type='input' class='form-control' id='name' name='name' placeholder='Type Designation' value='$name'>
						".wp_nonce_field( 'update_designation_nonce_action', 'update_designation_nonce_name' )."
					</td>
				</tr>
				<tr>
					<td><label>Color</label></td>
					<td><input type='color' class='form-control' id='color' name='color' value='$color'></td>
				</tr>
				<tr>
					<td><label>Staus</label></td>
					<td>
						<select id='status' name='status' class='form-control'>
							<optgroup label='Select Any Status'>
								<option value='1'>Available</option>
								<option value='0'>Unavailable</option>
							</optgroup>
						</select>
					</td>
				</tr>
			</table>
			</div>";
		} else {
			echo "<div id='action-result'>Error: Unable to fetch data.</div>";
		}
	}
	
	//update-now
	if($action == "update-now") {
		if ( ! wp_verify_nonce( $_POST['update_designation_nonce_name'], 'update_designation_nonce_action' ) ) {
			print 'Sorry, your update designation nonce did not verify.';
			exit;
		} else {
			// nonce verified - process form data
			$id = sanitize_text_field($_POST['id']);
			$name = sanitize_text_field($_POST['name']);
			$color = sanitize_text_field($_POST['color']);
			$status = sanitize_text_field($_POST['status']);
			if($wpdb->query($wpdb->prepare("UPDATE `$staff_category_table` SET `name` = %s, `color` = %s, `status` = %s WHERE `id` = %d", $name, $color, $status, $id))) {
			?><div id='update-now-action-result'><?php _e('Success: Designation updated.', CIP_TXTDM );?></div>
				<?php } else { ?><div id='action-result'><?php _e('Error: Unable to update designation.', CIP_TXTDM );?> </div>
		<?php }
		}
	}
	
	//delete
	if($action == "delete") {
		$id = sanitize_text_field($_POST['id']);
		if($wpdb->query($wpdb->prepare("DELETE FROM `$staff_category_table` WHERE `id` = %s", $id))) {
			?>
			<div id='action-result'><?php _e('Success: Designation deleted.', CIP_TXTDM );?></div>
		<?php } else { ?>
			<div id='action-result'><?php _e('Error: Unable to delete designation.', CIP_TXTDM );?></div>
		<?php }
	}
}
?>