<?php
// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

wp_enqueue_script('jquery');
wp_enqueue_script('jquery-ui-core');
wp_enqueue_script('jquery-ui-datepicker');
wp_enqueue_style('jquery-ui-css', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css');

global $wpdb;
$staff_attendance_table = $wpdb->prefix . "sm_attendance";
$staff_table = $wpdb->prefix . "sm_staffs";
$staff_category_table = $wpdb->prefix . "sm_staff_category";
$date_format = get_option('date_format');
$time_format = get_option('time_format');
$current_date = date("Y-m-d");
$filter_name = "1";
$region = $city = $country = '';
if(isset($_POST['filter_name'])) {
	$filter_name = $_POST['filter_name'];
}
$attend_filter_name = "1";
if(isset($_POST['attend_filter_name'])) {
	$attend_filter_name = $_POST['attend_filter_name'];
}
$userid = -2;
if(isset($_POST['staff_id'])) {
	$userid = $_POST['staff_id'];
}
$all_dates = array();
//print_r($current_user);
//print_r($_POST);


//Function to sum working hours //
function AddPlayTime($times) {
    $minutes = 0; //declare minutes either it gives Notice: Undefined variable
    // loop throught all the times
    foreach ($times as $time) {
        list($hour, $minute) = explode(':', $time);
        $minutes += $hour * 60;
        $minutes += $minute;
    }

    $hours = floor($minutes / 60);
    $minutes -= $hours * 60;

    // returns the time already formatted
    return sprintf('%02d Hours and %02d Min', $hours, $minutes);
}

?>
<style>
table {
	background-color: #FFFFFF !important;
}
</style>
<div class="wl_im">
<h1><?php _e('Mange Reports', CIP_TXTDM );?></h1>
<!-- filter table-->
<br>
<form id="get-report" name="get-report" method="POST">
<table class="table">
	<tr>
		<td class="sm-labels">
			<!-- staffs -->
			<?php _e('Staff(s)', CIP_TXTDM );?>
			<select id="staff_id" name="staff_id">
				<optgroup label="Select Staff">
				<?php
				if(count($all_staffs = $wpdb->get_results( $wpdb->prepare("SELECT * FROM `$staff_table` WHERE `status` = %d", 1) ))) {
					foreach($all_staffs as $staff_data) {
						$staff_id = $staff_data->staff_id;
						$user_info = get_userdata( $staff_id );
						if(!empty($user_info)){						
						$email = $user_info->user_email;
						$fname = $user_info->first_name;
						$lname = $user_info->last_name;
						$fullname = ucwords($fname." ".$lname);
						?>
						<option value="<?php echo $staff_id; ?>" <?php if($userid == $staff_id) echo "selected=selected"; ?>><?php echo $fullname; ?> (<?php echo $email; ?>)</option>
						<?php
					} }
				} else { ?>
				<option readonly><?php _e('No Staff Available', CIP_TXTDM );?></option>
				<?php 
				} ?>
				</optgroup>
			</select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<?php _e('Filter', CIP_TXTDM );?>
			<!-- filter -->
			<select id="filter_name" name="filter_name">
				<optgroup label="Select Any Filter">
				<option value="1" <?php if($filter_name == "1") echo "selected=selected"; ?>><?php _e('This Month', CIP_TXTDM );?></option>
				<option value="2" <?php if($filter_name == "2") echo "selected=selected"; ?>><?php _e('Previous Month', CIP_TXTDM );?></option>
				<option value="3" <?php if($filter_name == "3") echo "selected=selected"; ?>><?php _e('Previous Three Month', CIP_TXTDM );?></option>
				<option value="6" <?php if($filter_name == "6") echo "selected=selected"; ?>><?php _e('Previous Six Month', CIP_TXTDM );?></option>
				<option value="9" <?php if($filter_name == "9") echo "selected=selected"; ?>><?php _e('Previous Nine Month', CIP_TXTDM );?></option>
				<option value="12" <?php if($filter_name == "12") echo "selected=selected"; ?>><?php _e('Previous One Year', CIP_TXTDM );?></option>
				</optgroup>
			</select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<select id="attend_filter_name" name="attend_filter_name">
				<optgroup label="Select Any Filter">
				<option value="1" <?php if($attend_filter_name == "1") echo "selected=selected"; ?>><?php _e('All Days', CIP_TXTDM );?></option>
				<option value="2" <?php if($attend_filter_name == "2") echo "selected=selected"; ?>><?php _e('Only Attend days', CIP_TXTDM );?></option>
				<option value="3" <?php if($attend_filter_name == "3") echo "selected=selected"; ?>><?php _e('Only Absent Days', CIP_TXTDM );?></option>
				</optgroup>
			</select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<button type="submit" class="btn btn-info get_report_btn"><?php _e('Get Report', CIP_TXTDM );?></button>
		</td>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
		<td>&nbsp;</td>		
	</tr>
</table>
</form>

	<?php
	if(isset($_POST['filter_name']) && isset($_POST['staff_id'])) {
		$filter_name = sanitize_text_field($_POST['filter_name']);
		$attend_filter_name = sanitize_text_field($_POST['attend_filter_name']);
		$userid = sanitize_text_field($_POST['staff_id']);
		
		// check id user exist
		if($user_info = get_userdata( $userid )) {
			//get user info
			$user_info = get_userdata( $userid );
			$email = $user_info->user_email;
			$fname = $user_info->first_name;
			$lname = $user_info->last_name;
			$fullname = ucwords($fname." ".$lname);
		}
		if($filter_name == 1) $filter_selected ="This Month";
		elseif($filter_name == 2) $filter_selected ="Past Month";
		elseif($filter_name == 3) $filter_selected ="Past Three Month";
		elseif($filter_name == 6) $filter_selected ="Past Six Month";
		elseif($filter_name == 9) $filter_selected ="Past Nine Month";
		elseif($filter_name == 12) $filter_selected ="Past One Year";
		elseif($attend_filter_name == 1) $attend_filter_selected ="All days";
		elseif($attend_filter_name == 2) $attend_filter_selected ="Only Attend days";
		elseif($attend_filter_name == 3) $attend_filter_selected ="Only absent days";
		echo "<h2>$filter_selected Report Generated For: $fullname</h2>";
	}
	?>

<!-- record table-->
<table class="table table-stripped">
	<thead>
		<tr class="info main_tb_head">
			<th>#</th>
			<th><?php _e('Name', CIP_TXTDM );?></th>
			<th><?php _e('Date', CIP_TXTDM );?></th>
			<th><?php _e('Office In', CIP_TXTDM );?></th>
			<th><?php _e('Office Out', CIP_TXTDM );?></th>
			<th><?php _e('Lunch In', CIP_TXTDM );?></th>
			<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
			<th><?php _e('Break Time', CIP_TXTDM );?></th>
			<th><?php _e('Work Hour', CIP_TXTDM );?></th>
			<th><?php _e('IP', CIP_TXTDM );?></th>
			<th><?php _e('Location', CIP_TXTDM );?></th>
			<th><?php _e('Action', CIP_TXTDM );?></th>
		<tr>
	<thead>
		<?php if(isset($_POST['filter_name']) && isset($_POST['staff_id'])) { ?>
	<tbody>
	<?php
	
		$filter_name = sanitize_text_field($_POST['filter_name']);
		$userid = sanitize_text_field($_POST['staff_id']);
		$attend_filter_name = sanitize_text_field($_POST['attend_filter_name']);
		// check id user exist
		if($user_info = get_userdata( $userid )) {
			//get user info
			$user_info = get_userdata( $userid );
			$email = $user_info->user_email;
			$fname = $user_info->first_name;
			$lname = $user_info->last_name;
			$fullname = ucwords($fname." ".$lname);
			//set file parameter
			$upload_dir_all = wp_upload_dir();
			$upload_dir_path = $upload_dir_all['basedir'];
			$upload_dir_url = $upload_dir_all['baseurl'];
			if($attend_filter_name == "1"){
				if($filter_name == "1") $file_name = $fname."-".$lname."-this-month-report.csv";
				elseif($filter_name == "2") $file_name = $fname."-".$lname."-previous-month-report.csv";
				elseif($filter_name == "3") $file_name = $fname."-".$lname."-previous-three-month-report.csv";
				elseif($filter_name == "6") $file_name = $fname."-".$lname."-previous-six-month-report.csv";
				elseif($filter_name == "9") $file_name = $fname."-".$lname."-previous-nine-month-report.csv";
				elseif($filter_name == "12") $file_name = $fname."-".$lname."-previous-one-year-report.csv";
				elseif($filter_name == "all") $file_name = $fname."-".$lname."-all-time-report.csv";			
			}elseif($attend_filter_name == "2"){
				if($filter_name == "1") $file_name = $fname."-".$lname."-this-month-Attend-report.csv";
				elseif($filter_name == "2") $file_name = $fname."-".$lname."-previous-month-Attend-report.csv";
				elseif($filter_name == "3") $file_name = $fname."-".$lname."-previous-three-month-Attend-report.csv";
				elseif($filter_name == "6") $file_name = $fname."-".$lname."-previous-six-month-Attend-report.csv";
				elseif($filter_name == "9") $file_name = $fname."-".$lname."-previous-nine-month-Attend-report.csv";
				elseif($filter_name == "12") $file_name = $fname."-".$lname."-previous-one-year-Attend-report.csv";
				elseif($filter_name == "all") $file_name = $fname."-".$lname."-all-time-Attend-report.csv";			
			}elseif($attend_filter_name == "3"){
				if($filter_name == "1") $file_name = $fname."-".$lname."-this-month-leave-report.csv";
				elseif($filter_name == "2") $file_name = $fname."-".$lname."-previous-month-leave-report.csv";
				elseif($filter_name == "3") $file_name = $fname."-".$lname."-previous-three-month-leave-report.csv";
				elseif($filter_name == "6") $file_name = $fname."-".$lname."-previous-six-month-leave-report.csv";
				elseif($filter_name == "9") $file_name = $fname."-".$lname."-previous-nine-month-leave-report.csv";
				elseif($filter_name == "12") $file_name = $fname."-".$lname."-previous-one-year-leave-report.csv";
				elseif($filter_name == "all") $file_name = $fname."-".$lname."-all-time-leave-report.csv";			
			}
			//create a file
			$report_file = fopen($upload_dir_path."/".$file_name, "w") or die("Unable to create report file!");
			$headertext = "No., Date, Name, Office In, Office Out, Lunch In, lunch Out, Break Time, Working Hours, IP, Location \n";
			fwrite($report_file, $headertext);
			$fullname = ucwords($fname." ".$lname);

			//this month report
			if($filter_name == "1") {
				$startdate = date("Y-m-01");
				$enddate = date("Y-m-d");			
				$i = strtotime($startdate);
				$j = strtotime($enddate);
				for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
					$all_dates[] = date("Y-m-d", $i);
				}		
			}
			
			//last month report
			elseif($filter_name == "2") {
				$startdate = date("Y-m-01", strtotime("-1 month"));
				$enddate = date("Y-m-t", strtotime($startdate));			
				$i = strtotime($startdate);
				$j = strtotime($enddate);
				for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
					$all_dates[] = date("Y-m-d", $i);
				}
			}
			
			//last 3 month report
			elseif($filter_name == "3") {
				$startdate = date("Y-m-01", strtotime("-3 month"));
				$enddate = date("Y-m-t", strtotime($startdate));
				$enddate = date("Y-m-d", strtotime("+2 month", strtotime($enddate)));
				$i = strtotime($startdate);
				$j = strtotime($enddate);
				for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
					$all_dates[] = date("Y-m-d", $i);
				}
			}
			//last 6 month report
			elseif($filter_name == "6") {
				$startdate = date("Y-m-01", strtotime("-6 month"));
				$enddate = date("Y-m-t", strtotime($startdate));
				$enddate = date("Y-m-d", strtotime("+5 month", strtotime($enddate)));
				$i = strtotime($startdate);
				$j = strtotime($enddate);
				for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
					$all_dates[] = date("Y-m-d", $i);
				}
			}	
			//last 9 month report
			elseif($filter_name == "9") {
				$startdate = date("Y-m-01", strtotime("-9 month"));
				$enddate = date("Y-m-t", strtotime($startdate));
				$enddate = date("Y-m-d", strtotime("+8 month", strtotime($enddate)));
				$i = strtotime($startdate);
				$j = strtotime($enddate);
				for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
					$all_dates[] = date("Y-m-d", $i);
				}
			}
			//last 12 month report
			elseif($filter_name == "12") {
				$startdate = date("Y-m-01", strtotime("-12 month"));
				$enddate = date("Y-m-t", strtotime($startdate));
				$enddate = date("Y-m-d", strtotime("+11 month", strtotime($enddate)));
				$i = strtotime($startdate);
				$j = strtotime($enddate);
				for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
					$all_dates[] = date("Y-m-d", $i);
				}
			}
			
			$no = 1;
			$flag = 0;
			$work_array1 = array();
			$work_array2 = array();
			$work_array3 = array();
			foreach($all_dates as $row_date) {
				$row = $wpdb->get_row( $wpdb->prepare("SELECT * FROM `$staff_attendance_table` WHERE `staff_id` = %d AND `date` LIKE %s", $userid, $row_date) );
				//print_r($row);
			if($attend_filter_name == "1"){	
				if(count($row)) {
					$flag = 1;
					$id = $row->id;
					$date = $row->date;
					$office_in = $row->office_in;
					$office_out = $row->office_out;
					$datep = $row->date;
					if($office_out!='00:00:00')
						{
							$dteStart = new DateTime($row->office_in); 
							$dteEnd   = new DateTime($row->office_out); 
							$dteDiff  = $dteStart->diff($dteEnd); 
							$work_hour = $dteDiff->format("%H:%I:%S");
							array_push($work_array1,$work_hour);
						}elseif ($office_out=="00:00:00" && $office_in!="00:00:00") {
							$sepparator = '-';
							$parts = explode($sepparator, $datep);
							$dayForDate = date("l", mktime(0, 0, 0, $parts[1], $parts[2], $parts[0]));
							$strStart = $row->office_in; 
							if($dayForDate=="Saturday")
							{
								$strEnd   = '15:00:00'; 
							}
							else
							{
								$strEnd   = '19:00:00'; 
							}
							$dteStart = new DateTime($strStart); 
							$dteEnd   = new DateTime($strEnd); 
							$dteDiff  = $dteStart->diff($dteEnd); 
							$work_hour = $dteDiff->format("%H:%I:%S");
							array_push($work_array3,$work_hour);
						}else
						{
							$work_hour = $row->today_total_hours;
							array_push($work_array2,$work_hour);
						}
					
					$lunch_in = $row->lunch_in;
					$lunch_out = $row->lunch_out;
					$lunch_out = $row->lunch_out;
					$user_ip = $row->ip;

					// if any time == 00:00:00 
					if($office_in == "00:00:00") $office_in = "None"; else $office_in = date($time_format, strtotime($office_in));
					if($office_out == "00:00:00") $office_out = "None"; else $office_out = date($time_format, strtotime($office_out));
					if($lunch_in == "00:00:00") $lunch_in = "None"; else $lunch_in = date($time_format, strtotime($lunch_in));
					if($lunch_out == "00:00:00") $lunch_out = "None"; else $lunch_out = date($time_format, strtotime($lunch_out));
					if(date("l", strtotime($date)) == "Sunday") {
						$date = date($date_format, strtotime($date));
						$office_in = "Sunday";
						$office_out = "Sunday";
						$lunch_in = "Sunday";
						$lunch_out = "Sunday";
						$today_total_hours = "Sunday";
						$user_ip = "Sunday";
						$work_hour = "Sunday";
					} else {
						$date = date($date_format, strtotime($date));
					}					
				?>
			<tr class="<?php if($office_in == "Sunday") echo "success sunday_tb"; ?>">
				<td><?php echo $no; ?>.</td>
				<td><?php echo $fullname; ?></td>
				<td><?php echo $date; ?></td>
				<td><?php echo $office_in; ?></td>
				<td><?php echo $office_out; ?></td>
				<td><?php echo $lunch_in; ?></td>
				<td><?php echo $lunch_out; ?></td>
				<td>
					<?php $dteStart = new DateTime($row->break_in); 
					$dteEnd   = new DateTime($row->break_out); 
					$dteDiff  = $dteStart->diff($dteEnd); 
					echo $break_hour = $dteDiff->format("%H:%I:%S"); ?>
				</td>
				<td><?php if($office_in != "00:00:00") { echo $work_hour; } else { echo 'None'; } ?></td>
				<td><?php if($office_in != "") { echo $user_ip; } else { echo "None"; } ?></td>
				<td><?php if($office_in != "00:00:00") { echo $row->user_location; } else { echo "None"; } ?></td>
				<td><?php if($office_in != "00:00:00") { ?>
					<button id="view-report" name="view-report" class="btn btn-info" data-toggle="modal" data-target="#ViewModal" onclick="return ViewReport('<?php echo $id; ?>', '<?php echo $userid; ?>', '<?php echo $row->date; ?>');">View Report</button>
					<button id="edit-record" name="edit-record" class="btn btn-primary" data-toggle="modal" data-target="#EditModal" onclick="return EditRecord('<?php echo $id; ?>', '<?php echo $userid; ?>', '<?php echo $row->date; ?>');">Edit</button>
					<?php } else { echo 'No report'; } ?>
				</td>
			</tr>
			<?php
					//add records
					$date = date("d M y", strtotime($date));
					$txt = "$no, $date, $fullname, $office_in, $office_out, $lunch_in, $lunch_out, $break_hour, $work_hour , $user_ip, $region,$city,$country \n";
					fwrite($report_file, $txt);
				} else {
					//check if Sunday else no record found
					if(date("l", strtotime($row_date)) == "Sunday") {
						$date = date($date_format, strtotime($row_date));
						$office_in = "Sunday";
						$office_out = "Sunday";
						$lunch_in = "Sunday";
						$lunch_out = "Sunday";
						$work_hour = "Sunday";
						$user_ip = "Sunday";
					} else {
						$date = date($date_format, strtotime($row_date));
						$office_in = "Sorry";
						$office_out = "No";
						$lunch_in = "Record";
						$lunch_out = "Found";
						$work_hour = '';
						$user_ip = "";
					}
			?>
			<tr class="<?php if($office_in == "Sunday") echo "success sunday_tb"; ?>">
				<td><?php echo $no; ?>.</td>
				<td><?php echo $fullname; ?></td>
				<td><?php echo $date; ?></td>
				<td><?php echo $office_in; ?></td>
				<td><?php echo $office_out; ?></td>
				<td><?php echo $lunch_in; ?></td>
				<td><?php echo $lunch_out; ?></td>
				<td>
					<?php $dteStart = new DateTime($row->break_in); 
					$dteEnd   = new DateTime($row->break_out); 
					$dteDiff  = $dteStart->diff($dteEnd); 
					echo $break_hour = $dteDiff->format("%H:%I:%S"); ?>
				</td>
				<td><?php if($office_in != "00:00:00") { echo $work_hour; } else { echo 'None'; } ?></td>
				<td><?php if($office_in != "") { echo $user_ip; } else { echo "None"; } ?></td>
				<td><?php if(isset($row->user_location)){ echo $row->user_location; } ?></td>
				<td>&nbsp;</td>
			</tr>
			<?php
					//add no record found
					$date = date("d M y", strtotime($date));
					$txt = "$no, $date, $fullname, $office_in, $office_out, $lunch_in, $lunch_out, $break_hour, $work_hour, $user_ip, $region,$city,$country \n";
					fwrite($report_file, $txt);
					
				}
				$no++;
			}elseif($attend_filter_name == "2"){
				if((date("l", strtotime($row_date)) != "Sunday") && (count($row)) ) { 
					//check if Sunday else no record found					
					$flag = 1;
					$id = $row->id;
					$date = $row->date;
					$office_in = $row->office_in;
					$office_out = $row->office_out;
					$lunch_in = $row->lunch_in;
					$lunch_out = $row->lunch_out;
					$lunch_out = $row->lunch_out;

					$user_ip = $row->ip;
					$query = @unserialize(file_get_contents('http://ip-api.com/php/'.$user_ip));
					if($query && $query['status'] == 'success') {
					 // echo 'Hello visitor from '.$query['country'].', '.$query['city'].'!';
					  $region = $query['regionName'].""; 
				      $city = $query['city'].""; 
				      $country = $query['country'];
					}

					if($office_out!='00:00:00')
						{
							$dteStart = new DateTime($row->office_in); 
							$dteEnd   = new DateTime($row->office_out); 
							$dteDiff  = $dteStart->diff($dteEnd); 
							$work_hour = $dteDiff->format("%H:%I:%S");
							array_push($work_array1,$work_hour);
						} else
						{
							$work_hour = $row->today_total_hours;
							array_push($work_array2,$work_hour);
						}	
					// if any time == 00:00:00 
					if($office_in == "00:00:00") $office_in = "None"; else $office_in = date($time_format, strtotime($office_in));
					if($office_out == "00:00:00") $office_out = "None"; else $office_out = date($time_format, strtotime($office_out));
					if($lunch_in == "00:00:00") $lunch_in = "None"; else $lunch_in = date($time_format, strtotime($lunch_in));
					if($lunch_out == "00:00:00") $lunch_out = "None"; else $lunch_out = date($time_format, strtotime($lunch_out));
					if(date("l", strtotime($date)) == "Sunday") {
						$date = date($date_format, strtotime($date));
						$office_in = "Sunday";
						$office_out = "Sunday";
						$lunch_in = "Sunday";
						$lunch_out = "Sunday";
						$today_total_hours = "Sunday";
						$user_ip = "Sunday";
						$work_hour = "Sunday";	
					} else {
						$date = date($date_format, strtotime($date));
					}
					//}
				
			?>
			<tr class="<?php if($office_in == "Sunday") echo "success sunday_tb"; ?>">
				<td><?php echo $no; ?>.</td>
				<td><?php echo $fullname; ?></td>
				<td><?php echo $date; ?></td>
				<td><?php echo $office_in; ?></td>
				<td><?php echo $office_out; ?></td>
				<td><?php echo $lunch_in; ?></td>
				<td><?php echo $lunch_out; ?></td>
				<td>
					<?php $dteStart = new DateTime($row->break_in); 
					$dteEnd   = new DateTime($row->break_out); 
					$dteDiff  = $dteStart->diff($dteEnd); 
					echo $break_hour = $dteDiff->format("%H:%I:%S"); ?>
				</td>
				<td><?php if($office_in != "00:00:00") { echo $work_hour; } else { echo 'None'; } ?></td>
				<td><?php if($office_in != "") { echo $user_ip; } else { echo "None"; } ?></td>
				<td><?php if($office_in != "00:00:00") { echo $row->user_location; } else { echo "None"; } ?></td>
				<td>&nbsp;</td>
			</tr>
			<?php
					//add no record found
					$date = date("d M y", strtotime($date));
					$txt = "$no, $date, $fullname, $office_in, $office_out, $lunch_in, $lunch_out, $break_hour, $work_hour, $user_ip, $region,$city,$country \n";
					fwrite($report_file, $txt);
					$no++;
				}
				
			}elseif($attend_filter_name == "3"){
				if((date("l", strtotime($row_date)) != "Sunday") && (!count($row)) ) { 
					//check if Sunday else no record found					
						$flag=1;
						$date = date($date_format, strtotime($row_date));
						$office_in = "Sorry";
						$office_out = "No";
						$lunch_in = "Record";
						$lunch_out = "Found";
						$user_ip = "";
						$work_hour = "";
					//}
				
			?>
			<tr class="<?php if($office_in == "Sunday") echo "success sunday_tb"; ?>">
				<td><?php echo $no; ?>.</td>
				<td><?php echo $fullname; ?></td>
				<td><?php echo $date; ?></td>
				<td><?php echo $office_in; ?></td>
				<td><?php echo $office_out; ?></td>
				<td><?php echo $lunch_in; ?></td>
				<td><?php echo $lunch_out; ?></td>
				<td><?php $dteStart = new DateTime($row->break_in); 
					$dteEnd   = new DateTime($row->break_out); 
					$dteDiff  = $dteStart->diff($dteEnd); 
					echo $break_hour = $dteDiff->format("%H:%I:%S"); ?></td>
				<td><?php if($office_in != "00:00:00") { echo $work_hour; } else { echo 'None'; } ?></td>
				<td><?php if($office_in != "") { echo $user_ip; } else { echo "None"; } ?></td>
				<td>&nbsp;</td>
			</tr>
			<?php
					//add no record found
					$date = date("d M y", strtotime($date));
					$txt = "$no, $date, $fullname, $office_in, $office_out, $lunch_in, $lunch_out, $break_hour, $work_hour, $user_ip, $region,$city,$country \n";
					fwrite($report_file, $txt);
					$no++;
				}
				
			}
			}//end of foreach

			if($flag) { 
				$work_hourup = array_merge($work_array1,$work_array2,$work_array3);
				echo "<tr><td></td><td></td><td></td><td></td><td></td><td></td><td></td><td></td><td>Total:- '".AddPlayTime($work_hourup)."' </td><td></td><td></td><td></td></tr>
				<tr><td colspan=9><a href='".$upload_dir_url."/".$file_name."' class='btn btn-danger custom_download'><i class='fa fa-download' aria-hidden='true'></i> Download Report</a></td><td></td><td></td></tr>";
			}
			
		
		}else { ?>
			 <tr>
			 	<td colspan=9><?php _e("Sorry! This user doesn't exist.", CIP_TXTDM );?></td>
			 	<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
			 </tr>
		<?php }	?>
	</tbody>
	<?php }else{ // end isset ?>
	<tbody>	
		<tr>
			<td><?php _e('No data Found', CIP_TXTDM );?></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>
			<td></td>

		</tr>
	</tbody>
	<?php } ?>		
	<thead>
		<tr class="info main_tb_head">
			<th>#</th>
			<th><?php _e('Name', CIP_TXTDM );?></th>
			<th><?php _e('Date', CIP_TXTDM );?></th>
			<th><?php _e('Office In', CIP_TXTDM );?></th>
			<th><?php _e('Office Out', CIP_TXTDM );?></th>
			<th><?php _e('Lunch In', CIP_TXTDM );?></th>
			<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
			<th><?php _e('Break Time', CIP_TXTDM );?></th>
			<th><?php _e('Work Hour', CIP_TXTDM );?></th>
			<th><?php _e('IP', CIP_TXTDM );?></th>
			<th><?php _e('Location', CIP_TXTDM );?></th>
			<th><?php _e('Action', CIP_TXTDM );?></th>
		<tr>
	<thead>
</table>
<script>
function ViewReport(id, staff_id, date){
	console.log(id + staff_id);
	jQuery("#view-report-result").remove();
	jQuery.ajax({
		type: "post",
		url: location.href,
		data: "&id=" + id + "&staff_id=" + staff_id + "&date=" + date + "&action=view",
		contentType: "application/x-www-form-urlencoded",
		success: function(responseData, textStatus, jqXHR) {
			var result = jQuery(responseData).find('div#view-report-result');
			jQuery(".view-modal-body").html(result);
		},
		error: function(jqXHR, textStatus, errorThrown) {
		}
	});
}
function EditRecord(id, staff_id, date){
	console.log(id + staff_id);
	jQuery("#edit-report-result").remove();
	jQuery.ajax({
		type: "post",
		url: location.href,
		data: "&id=" + id + "&staff_id=" + staff_id + "&date=" + date + "&action=edit",
		contentType: "application/x-www-form-urlencoded",
		success: function(responseData, textStatus, jqXHR) {
			var result = jQuery(responseData).find('div#edit-report-result');
			jQuery(".edit-modal-body").html(result);
		},
		error: function(jqXHR, textStatus, errorThrown) {
		}
	});
}

function UpdateRecoed(id, staff_id, date){
	jQuery("#update-report-result").hide();
	jQuery.ajax({
		type: "post",
		url: location.href,
		data:  jQuery("#update-record-form").serialize() + "&action=update",
		contentType: "application/x-www-form-urlencoded",
		success: function(responseData, textStatus, jqXHR) {
			var result = jQuery(responseData).find('div#update-report-result');
			jQuery("#update-record-form").after(result);
		},
		error: function(jqXHR, textStatus, errorThrown) {
		}
	});
}
// modal js 
jQuery('#ViewModal').on('shown.bs.modal', function () {
  jQuery('#myInput').focus()
});
jQuery('#EditModal').on('shown.bs.modal', function () {
  jQuery('#myInput').focus()
});
</script>

<!-- View Modal -->
<div class="modal fade" id="ViewModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog modal-lg modal-notify modal-info" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h4 class="modal-title text-white" id="myModalLabel"><?php _e('View Record', CIP_TXTDM );?></h4>
				<button type="button" class="close text-white" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
			</div>
			<div class="modal-body view-modal-body">
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal"><?php _e('Close', CIP_TXTDM );?></button>
			</div>
		</div>
	</div>
</div>

<!-- Edit Modal -->
<div class="modal fade" id="EditModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog modal-lg modal-notify modal-info" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h4 class="modal-title text-white" id="myModalLabel"><?php _e('Edit Record', CIP_TXTDM );?></h4>
				<button type="button" class="close text-white" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
			</div>
			<div class="modal-body edit-modal-body">
			</div>
			<div class="modal-footer">
				<button type="button" id="update-record" name="update-record" class="btn btn-default" onclick="return UpdateRecoed();"><?php _e('Update', CIP_TXTDM );?></button>
				<button type="button" class="btn btn-default" data-dismiss="modal"><?php _e('Close', CIP_TXTDM );?></button>
			</div>
		</div>
	</div>
</div>
</div>
<?php
// view fetch report
if(isset($_POST['id']) && isset($_POST['staff_id']) && isset($_POST['date']) && isset($_POST['action'])) {
	$id = sanitize_text_field($_POST['id']);
	$staff_id = sanitize_text_field($_POST['staff_id']);
	$date = sanitize_text_field($_POST['date']);
	//$date = date("Y-m-d", strtotime($_POST['date']));
	$action = sanitize_text_field($_POST['action']);
	
	$user_info = get_userdata( $staff_id );
	$email = $user_info->user_email;
	$fname = $user_info->first_name;
	$lname = $user_info->last_name;
	$fullname = ucwords($fname." ".$lname);
	
	if($action == "view") {	
		$view_query = $wpdb->prepare("SELECT * FROM `$staff_attendance_table` WHERE `id` = %d AND `staff_id` = %d AND `date` = %s", $id, $staff_id, $date);
		if($report_data = $wpdb->get_row($view_query)) {
			$id = $report_data->id;
			$date = $report_data->date;
			$office_in = $report_data->office_in;
			$office_out = $report_data->office_out;
			$lunch_in = $report_data->lunch_in;
			$lunch_out = $report_data->lunch_out;
			$user_ip = $report_data->ip;
			$extra = @unserialize($report_data->extra);
			$sever_name = $extra['SERVER_NAME'];
			$sever_ip_address = $extra['SERVER_ADDR'];
			$sever_remote_ip_address = $extra['REMOTE_ADDR'];
			$sever_bwoser_system_details = $extra['HTTP_USER_AGENT'];
			$server_software = $extra['SERVER_SOFTWARE'];
			$server_signature = $extra['SERVER_SIGNATURE'];
			$report = $report_data->report;

			if($office_out!='00:00:00')
			{
				$dteStart = new DateTime($report_data->office_in); 
				$dteEnd   = new DateTime($report_data->office_out); 
				$dteDiff  = $dteStart->diff($dteEnd); 
				$work_hour = $dteDiff->format("%H:%I:%S");
			} else
			{
				$work_hour = $report_data->today_total_hours;
			}

			if($office_in != "00:00:00") $office_in = date($time_format, strtotime($office_in));
			if($office_out != "00:00:00") $office_out = date($time_format, strtotime($office_out));
			if($lunch_in != "00:00:00") $lunch_in = date($time_format, strtotime($lunch_in));
			if($lunch_out != "00:00:00") $lunch_out = date($time_format, strtotime($lunch_out));

			$dteStart = new DateTime($report_data->break_in); 
			$dteEnd   = new DateTime($report_data->break_out); 
			$dteDiff  = $dteStart->diff($dteEnd); 
			$break_hour = $dteDiff->format("%H:%I:%S");
			?>
			<div id="view-report-result">
				<table class="table table-bordered">
					<tr>
						<th><?php _e('Name', CIP_TXTDM );?></th>
						<td><?php echo ucwords($fname." ".$lname); ?></td>
					<tr>
					<tr>
						<th><?php _e('Date', CIP_TXTDM );?></th>
						<td><?php echo $date; ?></td>
					<tr>
					<tr>
						<th><?php _e('Office In', CIP_TXTDM );?></th>
						<td><?php echo $office_in; ?></td>
					<tr>
					<tr>
						<th><?php _e('Office Out', CIP_TXTDM );?></th>
						<td><?php echo $office_out; ?></td>
					<tr>
					<tr>
						<th><?php _e('Lunch In', CIP_TXTDM );?></th>
						<td><?php echo $lunch_in; ?></td>
					<tr>
					<tr>
						<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
						<td><?php echo $lunch_out; ?></td>
					<tr>
					<tr>
						<th><?php _e('Break Time', CIP_TXTDM );?></th>
						<td><?php echo $break_hour; ?></td>
					<tr>
					<tr>
						<th><?php _e('Working Hours', CIP_TXTDM );?></th>
						<td><?php if($office_in != "00:00:00") { echo $work_hour;} else { echo "None"; } ?></td>
					<tr>
					<tr>
						<th><?php _e('IP Address', CIP_TXTDM );?></th>
						<td><?php if($office_in != "") { echo $user_ip; } else { echo "None"; } ?></td>
					<tr>
					<tr>
						<th><?php _e('Location', CIP_TXTDM );?></th>
						<td><?php if($office_in != "None") { echo $report_data->user_location; } else { echo "None"; } ?></td>
					<tr>
					<tr>
						<th colspan="2" class="text-center"><?php _e('Work Report', CIP_TXTDM );?></th>
					<tr>
					<tr>
						<td colspan="2"><?php echo "<pre>".$report."</pre>"; ?></td>
					<tr>
				</table>
			</div>		
			<?php
		} // end if view query
	}// end if view action check
	
	if($action == "edit") {
		$edit_query = $wpdb->prepare("SELECT * FROM `$staff_attendance_table` WHERE `id` = %d AND `staff_id` = %d AND `date` = %s", $id, $staff_id, $date);
		if($report_data = $wpdb->get_row($edit_query)) {
			$id = $report_data->id;
			$date = $report_data->date;
			$office_in = $report_data->office_in;
			$office_out = $report_data->office_out;
			$lunch_in = $report_data->lunch_in;
			$lunch_out = $report_data->lunch_out;
			$report = $report_data->report;
			if($office_out!='00:00:00')
			{
				$dteStart = new DateTime($report_data->office_in); 
				$dteEnd   = new DateTime($report_data->office_out); 
				$dteDiff  = $dteStart->diff($dteEnd); 
				$work_hour = $dteDiff->format("%H:%I:%S");
			} else
			{
				$work_hour = $report_data->today_total_hours;
			}
			if($office_in != "00:00:00") $office_in = date($time_format, strtotime($office_in));
			if($office_out != "00:00:00") $office_out = date($time_format, strtotime($office_out));
			if($lunch_in != "00:00:00") $lunch_in = date($time_format, strtotime($lunch_in));
			if($lunch_out != "00:00:00") $lunch_out = date($time_format, strtotime($lunch_out));
			?>
			<div id="edit-report-result">
				<form id="update-record-form" name="update-record-form">
					<table class="table table-bordered">
						<tr>
							<th><?php _e('Name', CIP_TXTDM ); ?></th>
							<td>
								<?php echo ucwords($fname." ".$lname); ?>
								<input type="hidden" id="id" name="id" value="<?php echo $id; ?>">
								<input type="hidden" id="staff_id" name="staff_id" value="<?php echo $staff_id; ?>">
								<input type="hidden" id="date" name="date" value="<?php echo $date; ?>">
							</td>
						<tr>
						<tr>
							<th><?php _e('Date', CIP_TXTDM );?></th>
							<td><?php echo date("l, ".$date_format, strtotime($date)); ?></td>
						<tr>
						<tr>
							<th><?php _e('Office In', CIP_TXTDM );?></th>
							<td><input type="text" class="datetimepicker2" id="office_in" name="office_in" value="<?php echo $office_in; ?>"></td>
						<tr>
						<tr>
							<th><?php _e('Office Out', CIP_TXTDM );?></th>
							<td><input type="text" class="datetimepicker3" id="office_out" name="office_out" value="<?php echo $office_out; ?>"></td>
						<tr>
						<tr>
							<th><?php _e('Lunch In', CIP_TXTDM );?></th>
							<td><input type="text" class="datetimepicker4" id="lunch_in" name="lunch_in" value="<?php echo $lunch_in; ?>"></td>
						<tr>
						<tr>
							<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
							<td><input type="text" class="datetimepicker5" id="lunch_out" name="lunch_out" value="<?php echo $lunch_out; ?>"></td>
						<tr>
						<tr>
							<th><?php _e('Working Hours', CIP_TXTDM );?></th>
							<td><input type="text" class="datetimepicker5" id="today_total_hours" name="today_total_hours" value="<?php if($office_in != "00:00:00") { echo $work_hour;} else { echo "None"; } ?>"></td>
						<tr>
						<tr>
							<th><?php _e('IP Address', CIP_TXTDM );?></th>
							<td><input type="text"  id="user_ip" name="user_ip" value="<?php echo $report_data->ip; ?>"></td>
						<tr>
						<tr>
							<th><?php _e('Location', CIP_TXTDM );?></th>
							<td><input type="text"  id="location" name="location" value="<?php if($office_in != "None") {  echo $report_data->user_location; } else { echo "None"; } ?>"></td>
						<tr>
						<tr>
							<th colspan="2" class="text-center"><?php _e('Work Report', CIP_TXTDM );?></th>
						<tr>
						<tr>
							<td colspan="2"><?php echo "<pre>".$report."</pre>"; ?></td>
						<tr>
					</table>
				</form>
				<script>
				jQuery( document ).ready(function() {
					jQuery('.datetimepicker1').datetimepicker({
						format: 'YYYY:MM:DD',
					});
					jQuery('.datetimepicker2').datetimepicker({
						format: 'hh:mm A',
					});
					jQuery('.datetimepicker3').datetimepicker({
						format: 'hh:mm A',
					});
					jQuery('.datetimepicker4').datetimepicker({
						format: 'hh:mm A',
					});
					jQuery('.datetimepicker5').datetimepicker({
						format: 'hh:mm A',	
					});
				});
				</script>
			</div>
			<?php
		} // end if edit query
	}// end if edit action check
	
	if($action == "update") {
		$office_in = date("H:i:s", strtotime($_POST['office_in']));
		$office_out = date("H:i:s", strtotime($_POST['office_out']));
		$lunch_in = date("H:i:s", strtotime($_POST['lunch_in']));
		$lunch_out = date("H:i:s", strtotime($_POST['lunch_out']));		
		$user_ip = $_POST['user_ip'];	
		$update_query = $wpdb->prepare("UPDATE `$staff_attendance_table` SET `office_in` = %s, `office_out` = %s, `lunch_in` = %s, `lunch_out` = %s, `ip` = %s, `timestamp` = NOW() WHERE `id` = %d AND `staff_id` = %d AND `date` = %s", $office_in, $office_out, $lunch_in, $lunch_out, $user_ip, $id, $staff_id, $date);
		if($report_data = $wpdb->get_row($update_query)) {}
			?><div id='update-report-result' class='alert alert-success'>Success: report has been updated.</div><?php
	}
}// if fetch report
?>
