<?php
// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

//Function to sum working hours //
function AddPlayTime($times) {
    $minutes = 0; //declare minutes either it gives Notice: Undefined variable
    // loop throught all the times
    foreach ($times as $time) {
        list($hour, $minute) = explode(':', $time);
        $minutes += $hour * 60;
        $minutes += $minute;
    }

    $hours = floor($minutes / 60);
    $minutes -= $hours * 60;

    // returns the time already formatted
    return sprintf('%02d Hours and %02d Min', $hours, $minutes);
}

global $wpdb;
$staff_attendance_table = $wpdb->prefix . "sm_attendance";
$staff_table = $wpdb->prefix . "sm_staffs";
$staff_category_table = $wpdb->prefix . "sm_staff_category";

$date_format = get_option('date_format');
$time_format = get_option('time_format');

//$date_format = "d F y";
//$time_format = "g:i A";
$current_date = date("Y-m-d");
// get user details & id
$current_user = wp_get_current_user();
$username = $current_user->user_login;
$email = $current_user->user_email;
$fname = $current_user->user_firstname;
$lname = $current_user->user_lastname;
$fullname = ucwords($fname." ".$lname);
$userid = $current_user->ID;
$region = $city = $country = '';
//print_r($current_user);

//check logged-in user is Shift Monitor existing User (by ID)
if($userdata = $wpdb->get_row($wpdb->prepare("SELECT * FROM `$staff_table` WHERE `staff_id` = %d", $userid))) {
	// check user is active user
	$status = $userdata->status;
	if($status == 1) {
		//print_r($_POST);
		$filter_name = "1";
		$upload_dir_all = wp_upload_dir();
		$upload_dir_path = $upload_dir_all['basedir'];
		$upload_dir_url = $upload_dir_all['baseurl'];
		$all_dates = array();
		
		if(isset($_POST['filter_name'])) {
			$filter_name = $_POST['filter_name'];
		}

		//this month report
		if($filter_name == "1") {
			$startdate = date("Y-m-01");
			$enddate = date("Y-m-d");			
			$i = strtotime($startdate);
			$j = strtotime($enddate);
			for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
				$all_dates[] = date("Y-m-d", $i);
			}		
		}
		
		//last month report
		elseif($filter_name == "2") {
			$startdate = date("Y-m-01", strtotime("-1 month"));
			$enddate = date("Y-m-t", strtotime($startdate));			
			$i = strtotime($startdate);
			$j = strtotime($enddate);
			for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
				$all_dates[] = date("Y-m-d", $i);
			}
		}
		
		//last 3 month report
		elseif($filter_name == "3") {
			$startdate = date("Y-m-01", strtotime("-3 month"));
			$enddate = date("Y-m-t", strtotime($startdate));
			$enddate = date("Y-m-d", strtotime("+2 month", strtotime($enddate)));
			$i = strtotime($startdate);
			$j = strtotime($enddate);
			for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
				$all_dates[] = date("Y-m-d", $i);
			}
		}
		
		//last 6 month report
		elseif($filter_name == "6") {
			$startdate = date("Y-m-01", strtotime("-6 month"));
			$enddate = date("Y-m-t", strtotime($startdate));
			$enddate = date("Y-m-d", strtotime("+5 month", strtotime($enddate)));
			$i = strtotime($startdate);
			$j = strtotime($enddate);
			for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
				$all_dates[] = date("Y-m-d", $i);
			}
		}
		//last 9 month report
		elseif($filter_name == "9") {
			$startdate = date("Y-m-01", strtotime("-9 month"));
			$enddate = date("Y-m-t", strtotime($startdate));
			$enddate = date("Y-m-d", strtotime("+8 month", strtotime($enddate)));
			$i = strtotime($startdate);
			$j = strtotime($enddate);
			for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
				$all_dates[] = date("Y-m-d", $i);
			}
		}
		//last 12 month report
		elseif($filter_name == "12") {
			$startdate = date("Y-m-01", strtotime("-12 month"));
			$enddate = date("Y-m-t", strtotime($startdate));
			$enddate = date("Y-m-d", strtotime("+11 month", strtotime($enddate)));
			$i = strtotime($startdate);
			$j = strtotime($enddate);
			for($i; $i <= $j; $i = strtotime(date("Y-m-d", strtotime("+1 day", $i))) ) {
				$all_dates[] = date("Y-m-d", $i);
			}
		}
		?>
		<style>
		table {
			background-color: #FFFFFF !important;
		}
		</style>
		<h1><?php _e('Mange Reports', CIP_TXTDM );?></h1>
		<!-- filter table-->
		<br>
		<form id="get-report" name="get-report" method="POST">
		<table class="table">
			<tr>
				<td class="sm-labels">
					<?php _e('Show Report', CIP_TXTDM );?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
					<select id="filter_name" name="filter_name">
						<optgroup label="Select Any Filter">
						<option value="1" <?php if($filter_name == "1") echo "selected=selected"; ?>><?php _e('This Month', CIP_TXTDM );?></option>
						<option value="2" <?php if($filter_name == "2") echo "selected=selected"; ?>><?php _e('Previous Month', CIP_TXTDM );?></option>
						<option value="3" <?php if($filter_name == "3") echo "selected=selected"; ?>><?php _e('Previous Three Month', CIP_TXTDM );?></option>
						<option value="6" <?php if($filter_name == "6") echo "selected=selected"; ?>><?php _e('Previous Six Month', CIP_TXTDM );?></option>
						<option value="9" <?php if($filter_name == "9") echo "selected=selected"; ?>><?php _e('Previous Nine Month', CIP_TXTDM );?></option>
						<option value="12" <?php if($filter_name == "12") echo "selected=selected"; ?>><?php _e('Previous One Year', CIP_TXTDM );?></option>
						</optgroup>
					</select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
					<button type="submit" class="btn btn-info get_report_btn"><?php _e('Get Report', CIP_TXTDM );?></button>
				</td>
				<td>
					
				</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>		
			</tr>
			<tr class="custom-filter" style="display: none;">
				<td class="sm-labels"><?php _e('Start Date', CIP_TXTDM );?></td>
				<td><input type="date" id="start_date" name="start_date"></td>
				<td class="sm-labels"><?php _e('End Date', CIP_TXTDM );?></td>
				<td><input type="date" id="end_date" name="end_date"></td>
			</tr>
		</table>
		</form>
		<br>

		<!-- record table-->
		<table class="table table-stripped">
			<thead>
				<tr class="info main_tb_head">
					<th>#</th>
					<th><?php _e('Name', CIP_TXTDM );?></th>
					<th><?php _e('Date', CIP_TXTDM );?></th>
					<th><?php _e('Office In', CIP_TXTDM );?></th>
					<th><?php _e('Office Out', CIP_TXTDM );?></th>
					<th><?php _e('Lunch In', CIP_TXTDM );?></th>
					<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
					<th><?php _e('Break Time', CIP_TXTDM );?></th>
					<th><?php _e('Work Hour', CIP_TXTDM );?></th>
					<th><?php _e('IP', CIP_TXTDM );?></th>
					<th><?php _e('Location', CIP_TXTDM );?></th>
					<th><?php _e('Report', CIP_TXTDM );?></th>
				<tr>
			<thead>
			<tbody>
			<?php
				//create a file
				if($filter_name == "1") $file_name = $fname."-".$lname."-this-month-report.csv";
				elseif($filter_name == "2") $file_name = $fname."-".$lname."-previous-month-report.csv";
				elseif($filter_name == "3") $file_name = $fname."-".$lname."-previous-three-month-report.csv";
				elseif($filter_name == "6") $file_name = $fname."-".$lname."-previous-six-month-report.csv";
				elseif($filter_name == "9") $file_name = $fname."-".$lname."-previous-nine-month-report.csv";
				elseif($filter_name == "12") $file_name = $fname."-".$lname."-previous-one-year-report.csv";
				elseif($filter_name == "all") $file_name = $fname."-".$lname."-all-time-report.csv";

				$report_file = fopen($upload_dir_path."/".$file_name, "w") or die("Unable to create report file!");
				$headertext = "No., Date, Name, Office In, Office Out, Lunch In, lunch Out, Breal time, Working Hours, IP, Location \n";
				fwrite($report_file, $headertext);
				$fullname = ucwords($fname." ".$lname);
	
				$no = 1;
				$flag = 0;
				$work_array1 = array();
				$work_array2 = array();
				$work_array3 = array();
				foreach($all_dates as $row_date) {
					$row = $wpdb->get_row($wpdb->prepare("SELECT * FROM `$staff_attendance_table` WHERE `staff_id` = %d AND `date` LIKE %s", $userid, $row_date));
					//print_r($row);
					if(count($row)) {
						$flag = 1;
						$id = $row->id;
						$date = $row->date;
						$office_in = $row->office_in;
						$office_out = $row->office_out;
						$lunch_in = $row->lunch_in;
						$lunch_out = $row->lunch_out;
						$extra = @unserialize($row->extra);
						$sever_name = $extra['SERVER_NAME'];
						$sever_ip_address = $extra['SERVER_ADDR'];
						$sever_remote_ip_address = $extra['REMOTE_ADDR'];
						$sever_bwoser_system_details = $extra['HTTP_USER_AGENT'];
						$server_software = $extra['SERVER_SOFTWARE'];
						$server_signature = $extra['SERVER_SIGNATURE'];
						$report = $row->report;
						//Location fetch
						$user_ip = $row->ip;
						
						$datep = $row->date;
						if($office_out!='00:00:00')
						{
							$dteStart = new DateTime($row->office_in); 
							$dteEnd   = new DateTime($row->office_out); 
							$dteDiff  = $dteStart->diff($dteEnd); 
							$work_hour = $dteDiff->format("%H:%I:%S");
							array_push($work_array1,$work_hour);
						}elseif ($office_out=="00:00:00" && $office_in!="00:00:00") {
							$sepparator = '-';
							$parts = explode($sepparator, $datep);
							$dayForDate = date("l", mktime(0, 0, 0, $parts[1], $parts[2], $parts[0]));
							$strStart = $row->office_in; 
							if($dayForDate=="Saturday")
							{
								$strEnd   = '15:00:00'; 
							}
							else
							{
								$strEnd   = '19:00:00'; 
							}
							$dteStart = new DateTime($strStart); 
							$dteEnd   = new DateTime($strEnd); 
							$dteDiff  = $dteStart->diff($dteEnd); 
							$work_hour = $dteDiff->format("%H:%I:%S");
							array_push($work_array3,$work_hour);
						}else
						{
							$work_hour = $row->today_total_hours;
							array_push($work_array2,$work_hour);
						}	

						// if any time == 00:00:00 
						if($office_in == "00:00:00") $office_in = "None"; else $office_in = date($time_format, strtotime($office_in));
						if($office_out == "00:00:00") $office_out = "None"; else $office_out = date($time_format, strtotime($office_out));
						if($lunch_in == "00:00:00") $lunch_in = "None"; else $lunch_in = date($time_format, strtotime($lunch_in));
						if($lunch_out == "00:00:00") $lunch_out = "None"; else $lunch_out = date($time_format, strtotime($lunch_out));
						
						if(date("l", strtotime($date)) == "Sunday") {
							$date = date($date_format, strtotime($date));
							$office_in = "Sunday";
							$office_out = "Sunday";
							$lunch_in = "Sunday";
							$lunch_out = "Sunday";
							$sever_ip_address = "";
							$report = "";
						} else {
							$date = date($date_format, strtotime($date));
						}						
					?>
				<tr class="<?php if($office_in == "Sunday") echo "success sunday_tb"; ?>">
					<td><?php echo $no; ?>.</td>
					<td><?php echo $fullname; ?></td>
					<td><?php echo $date; ?></td>
					<td><?php echo $office_in; ?></td>
					<td><?php echo $office_out; ?></td>
					<td><?php echo $lunch_in; ?></td>
					<td><?php echo $lunch_out; ?></td>
					<td>
					<?php $dteStart = new DateTime($row->break_in); 
					$dteEnd   = new DateTime($row->break_out); 
					$dteDiff  = $dteStart->diff($dteEnd); 
					echo $break_hour = $dteDiff->format("%H:%I:%S"); ?>
					</td>
					<td><?php echo $work_hour; ?></td>
					<td><?php echo $user_ip; ?></td>
					<td><?php if(isset($row->user_location)){ echo $row->user_location; } ?></td>
					<td><?php if($office_in != "None") { ?>
						<button id="view-report" name="view-report" class="btn btn-default" data-toggle="modal" data-target="#myModal" onclick="return ViewReport('<?php echo $id; ?>', '<?php echo $userid; ?>', '<?php echo $date; ?>');">View Report</button></td>
						<?php } else { echo 'No report'; } ?>
				</tr>
				<?php
						//add records
						$date = date("d M y", strtotime($date));
						$txt = "$no, $date, $fullname, $office_in, $office_out, $lunch_in, $lunch_out, $break_hour, work_hour, $user_ip, $region,$city,$country \n";
						fwrite($report_file, $txt);
					} else {
						//check if Sunday else no record found
						if(date("l", strtotime($row_date)) == "Sunday") {
							$date = date($date_format, strtotime($row_date));
							$office_in = "Sunday";
							$office_out = "Sunday";
							$lunch_in = "Sunday";
							$lunch_out = "Sunday";
							$user_ip = "Sunday";
							$work_hour = "Sunday";
							$report = "No report";
						} else {
							$date = date($date_format, strtotime($row_date));
							$office_in = "Sorry";
							$office_out = "No";
							$lunch_in = "Record";
							$lunch_out = "Found";
							$user_ip = "None";
							$report = "No report";
							$work_hour = "No Report";
						}						
				?>
				<tr class="<?php if($office_in == "Sunday") echo "success sunday_tb"; ?>">
					<td><?php echo $no; ?>.</td>
					<td><?php echo $fullname; ?></td>
					<td><?php echo $date; ?></td>
					<td><?php echo $office_in; ?></td>
					<td><?php echo $office_out; ?></td>
					<td><?php echo $lunch_in; ?></td>
					<td><?php echo $lunch_out; ?></td>
					<td>
					<?php $dteStart = new DateTime($row->break_in); 
					$dteEnd   = new DateTime($row->break_out); 
					$dteDiff  = $dteStart->diff($dteEnd); 
					echo $break_hour = $dteDiff->format("%H:%I:%S"); ?>
					</td>
					<td><?php echo $work_hour; ?></td>
					<td><?php echo $user_ip; ?></td>
					<td><?php if($office_in != "None") { echo $row->user_location; } else { echo "None"; } ?></td>
					<td><?php echo $report; ?></td>
				</tr>
				<?php
						//add no record found
						$date = date("d M y", strtotime($date));
						$txt = "$no, $date, $fullname, $office_in, $office_out, $lunch_in, $lunch_out, $break_hour,  $work_hour, $user_ip, \n";
						fwrite($report_file, $txt);
					}
					$no++;
				}//end of foreach
				if($flag) { 
				$work_hour = array();
				$work_hourup = array_merge($work_array1,$work_array2,$work_array3);
				?>
				<tr><td></td><td></td><td></td><td></td><td></td><td></td><td></td><td></td><td><?php echo AddPlayTime($work_hourup); ?></td><td></td><td></td><td></td></tr>
				 <tr><td colspan=8><a href='".$upload_dir_url."/".$file_name."' class='btn btn-danger custom_download'><i class='fa fa-download' aria-hidden='true'></i><?php _e('Download Report', CIP_TXTDM );?></a></td><td></td><td></td><td></td></tr>
				<?php }	?>
			</tbody>
			<thead>
				<tr class="info main_tb_head">
					<th>#</th>
					<th><?php _e('Name', CIP_TXTDM );?></th>
					<th><?php _e('Date', CIP_TXTDM );?></th>
					<th><?php _e('Office In', CIP_TXTDM );?></th>
					<th><?php _e('Office Out', CIP_TXTDM );?></th>
					<th><?php _e('Lunch In', CIP_TXTDM );?></th>
					<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
					<th><?php _e('Break Time', CIP_TXTDM );?></th>
					<th><?php _e('Work Hour', CIP_TXTDM );?></th>
					<th><?php _e('IP', CIP_TXTDM );?></th>
					<th><?php _e('Location', CIP_TXTDM );?></th>
					<th><?php _e('Report', CIP_TXTDM );?></th>
				<tr>
			<thead>
		</table>
		<?php
	} elseif($status == 2 || $Status == 3) { ?>
		<p class='alert alert-danger'><?php _e('Sorry! Your account is not activated. Please contact to your higher authority regarding your Inactive account.', CIP_TXTDM );?></p>
<?php	}
} else { ?>
	<?php _e('Sorry! this page is only available for Registered Staffs', CIP_TXTDM );?>
<?php }
// fetch report
if(isset($_POST['id']) && isset($_POST['staff_id']) && isset($_POST['date'])) {
	$id = $_POST['id'];
	$staff_id = $_POST['staff_id'];
	$date = date("Y-m-d", strtotime($_POST['date']));
	
	$view_query = $wpdb->prepare("SELECT * FROM `$staff_attendance_table` WHERE `id` = %d AND `staff_id` = %d AND `date` = %s", $id, $staff_id, $date);
	if($report_data = $wpdb->get_row($view_query)) {
		$id = $report_data->id;
		$date = $report_data->date;
		$office_in = $report_data->office_in;
		$office_out = $report_data->office_out;
		$lunch_in = $report_data->lunch_in;
		$lunch_out = $report_data->lunch_out;
		$report = $report_data->report;
		$user_ip = $report_data->ip;
	
		if($office_out!='00:00:00')
			{
				$dteStart = new DateTime($report_data->office_in); 
				$dteEnd   = new DateTime($report_data->office_out); 
				$dteDiff  = $dteStart->diff($dteEnd); 
				$work_hour = $dteDiff->format("%H:%I:%S");
			} else
			{
				$work_hour = $report_data->today_total_hours;
			}
		if($office_in != "00:00:00") $office_in = date($time_format, strtotime($office_in));
		if($office_out != "00:00:00") $office_out = date($time_format, strtotime($office_out));
		if($lunch_in != "00:00:00") $lunch_in = date($time_format, strtotime($lunch_in));
		if($lunch_out != "00:00:00") $lunch_out = date($time_format, strtotime($lunch_out));

		$dteStart = new DateTime($report_data->break_in); 
		$dteEnd   = new DateTime($report_data->break_out); 
		$dteDiff  = $dteStart->diff($dteEnd); 
		$break_hour = $dteDiff->format("%H:%I:%S");
		?>
		<div id="view-report-result">
			<table class="table table-bordered">
				<tr>
					<th><?php _e('Name', CIP_TXTDM );?></th>
					<td><?php echo ucwords($fname." ".$lname); ?></td>
				<tr>
				<tr>
					<th><?php _e('Date', CIP_TXTDM );?></th>
					<td><?php echo $date; ?></td>
				<tr>
				<tr>
					<th><?php _e('Office In', CIP_TXTDM );?></th>
					<td><?php echo $office_in; ?></td>
				<tr>
				<tr>
					<th><?php _e('Office Out', CIP_TXTDM );?></th>
					<td><?php echo $office_out; ?></td>
				<tr>
				<tr>
					<th><?php _e('Lunch In', CIP_TXTDM );?></th>
					<td><?php echo $lunch_in; ?></td>
				<tr>
				<tr>
					<th><?php _e('Lunch Out', CIP_TXTDM );?></th>
					<td><?php echo $lunch_out; ?></td>
				<tr>
				<tr>
					<th><?php _e('break Time', CIP_TXTDM );?></th>
					<td><?php echo $break_hour; ?></td>
				<tr>
				<tr>
					<th><?php _e('Working Hours', CIP_TXTDM );?></th>
					<td><?php echo $work_hour; ?></td>
				<tr>
				<tr>
					<th><?php _e('IP Address', CIP_TXTDM );?></th>
					<td><?php echo $user_ip; ?></td>
				<tr>
				<tr>
					<th><?php _e('Location', CIP_TXTDM );?></th>
					<td><?php if($office_in != "None") { echo $report_data->user_location; } else { echo "None"; } ?></td>
				<tr>
				<tr>
					<th colspan="2" class="text-center"><?php _e('Work Report', CIP_TXTDM );?></th>
				<tr>
				<tr>
					<td colspan="2"><?php echo "<pre>".$report."</pre>"; ?></td>
				<tr>
			</table>
		</div>		
		<?php
	}	
}// if fetch report
?>
<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
				<h4 class="modal-title" id="myModalLabel"><?php _e('View Report', CIP_TXTDM );?></h4>
			</div>
			<div class="modal-body">
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal"><?php _e('Close', CIP_TXTDM );?></button>
			</div>
		</div>
	</div>
</div>
<script>
function ViewReport(id, staff_id, date){
	console.log(id + staff_id);
	jQuery("#view-report-result").remove();
	jQuery.ajax({
		type: "post",
		url: location.href,
		data: "&id=" + id + "&staff_id=" + staff_id + "&date=" + date,
		contentType: "application/x-www-form-urlencoded",
		success: function(responseData, textStatus, jqXHR) {
			var result = jQuery(responseData).find('div#view-report-result');
			jQuery(".modal-body").html(result);
		},
		error: function(jqXHR, textStatus, errorThrown) {
		}
	});
}

// modal js 
jQuery('#myModal').on('shown.bs.modal', function () {
  jQuery('#myInput').focus()
});
</script>